

class Kuznechik(object):
    lvec = [
        0x94, 0x20, 0x85, 0x10, 0xC2, 0xC0, 0x01, 0xFB, 
        0x01, 0xC0, 0xC2, 0x10, 0x85, 0x20, 0x94, 0x01
    ]

    def mul_gf256(self, x, y):
        z = 0
        while y:
            if (y & 1):
                z ^=x
            x = (x << 1) ^ (0xC3 if (x & 0x80) else 0x00)
            x &= 0xFF
            y >>= 1
        return z & 0xFF

    def l_inv(self, w):
        for j in xrange(16):
            x = w[0]
            for i in xrange(15):
                w[i] = w[i+1]
                x ^= self.mul_gf256(w[i], self.lvec[i])
            w[15] = x
        return w

    def decrypt_block(self, k, bloc):
        x = [0 for i in xrange(16)]

        for i in xrange(16):
            x[i] = bloc[i] ^ k[9][i]

        for i in xrange(8, -1, -1):
            x = self.l_inv(x)
            for j in xrange(16):
                x[j] ^= k[i][j]

        return x

    def decrypt_block_without_key(self, bloc):
        for i in xrange(8, -1, -1):
            bloc = self.l_inv(bloc)
        return bloc


def d(x):
    return ((200 * x * x) + (255 * x) + 92) % 0x100

def deobfuscate(data):
    res = ""
    for i in xrange(len(data)):
        res += chr(d(ord(data[i])))
    return res

tab = [
    0xdc, 0x63, 0x7a, 0x21, 0x58, 0x1f, 0x76, 0x5d,
    0xd4, 0xdb, 0x72, 0x99, 0x50, 0x97, 0x6e, 0xd5,
    0xcc, 0x53, 0x6a, 0x11, 0x48, 0x0f, 0x66, 0x4d,
    0xc4, 0xcb, 0x62, 0x89, 0x40, 0x87, 0x5e, 0xc5,
    0xbc, 0x43, 0x5a, 0x01, 0x38, 0xff, 0x56, 0x3d,
    0xb4, 0xbb, 0x52, 0x79, 0x30, 0x77, 0x4e, 0xb5,
    0xac, 0x33, 0x4a, 0xf1, 0x28, 0xef, 0x46, 0x2d,
    0xa4, 0xab, 0x42, 0x69, 0x20, 0x67, 0x3e, 0xa5,
    0x9c, 0x23, 0x3a, 0xe1, 0x18, 0xdf, 0x36, 0x1d,
    0x94, 0x9b, 0x32, 0x59, 0x10, 0x57, 0x2e, 0x95,
    0x8c, 0x13, 0x2a, 0xd1, 0x08, 0xcf, 0x26, 0x0d,
    0x84, 0x8b, 0x22, 0x49, 0x00, 0x47, 0x1e, 0x85,
    0x7c, 0x03, 0x1a, 0xc1, 0xf8, 0xbf, 0x16, 0xfd,
    0x74, 0x7b, 0x12, 0x39, 0xf0, 0x37, 0x0e, 0x75,
    0x6c, 0xf3, 0x0a, 0xb1, 0xe8, 0xaf, 0x06, 0xed,
    0x64, 0x6b, 0x02, 0x29, 0xe0, 0x27, 0xfe, 0x65,
    0x5c, 0xe3, 0xfa, 0xa1, 0xd8, 0x9f, 0xf6, 0xdd,
    0x54, 0x5b, 0xf2, 0x19, 0xd0, 0x17, 0xee, 0x55,
    0x4c, 0xd3, 0xea, 0x91, 0xc8, 0x8f, 0xe6, 0xcd,
    0x44, 0x4b, 0xe2, 0x09, 0xc0, 0x07, 0xde, 0x45,
    0x3c, 0xc3, 0xda, 0x81, 0xb8, 0x7f, 0xd6, 0xbd,
    0x34, 0x3b, 0xd2, 0xf9, 0xb0, 0xf7, 0xce, 0x35,
    0x2c, 0xb3, 0xca, 0x71, 0xa8, 0x6f, 0xc6, 0xad,
    0x24, 0x2b, 0xc2, 0xe9, 0xa0, 0xe7, 0xbe, 0x25,
    0x1c, 0xa3, 0xba, 0x61, 0x98, 0x5f, 0xb6, 0x9d,
    0x14, 0x1b, 0xb2, 0xd9, 0x90, 0xd7, 0xae, 0x15,
    0x0c, 0x93, 0xaa, 0x51, 0x88, 0x4f, 0xa6, 0x8d,
    0x04, 0x0b, 0xa2, 0xc9, 0x80, 0xc7, 0x9e, 0x05,
    0xfc, 0x83, 0x9a, 0x41, 0x78, 0x3f, 0x96, 0x7d,
    0xf4, 0xfb, 0x92, 0xb9, 0x70, 0xb7, 0x8e, 0xf5,
    0xec, 0x73, 0x8a, 0x31, 0x68, 0x2f, 0x86, 0x6d,
    0xe4, 0xeb, 0x82, 0xa9, 0x60, 0xa7, 0x7e, 0xe5
]

print "Reading and deobfuscate data..."

data = open('payload.bin', 'rb').read()
data = data.decode('base64')
data = deobfuscate(data)

salt      = data[:16]
iv        = data[16:32]
encrypted = data[32:]

kuz = Kuznechik()
            
cleartext = "-Fancy Nounours-"
cleartext = [ord(x) for x in cleartext]

iv = [ord(x) for x in iv]

print "Get K from the cleartext attack..."

# CBC
cbc = [cleartext[i]^iv[i] for i in xrange(16)]

# Substitution
substitution = [tab.index(cbc[i]) for i in xrange(16)]
   
# Decrypt the first block without doing XOR operation involving key
block = [ord(x) for x in encrypted[:16]]
block = kuz.decrypt_block_without_key(block)

# Get K
K = [block[i]^substitution[i] for i in xrange(16)]

print "Found K : ", K

print "Now let's decrypt the whole payload..."

s = ""
for i in xrange(1, len(encrypted)/16):
    block = [ord(x) for x in encrypted[16*i:16*(i+1)]]
    iv = [ord(x) for x in encrypted[16*(i-1):16*i]]

    # Decrypt block without doing XOR operation involving key
    block = kuz.decrypt_block_without_key(block)

    # XOR with K
    res = [block[i] ^ K[i] for i in xrange(16)]

    # Substitution
    res = [tab[res[i]] for i in xrange(16)]

    # CBC
    res = [res[i] ^ iv[i] for i in xrange(16)]

    s += ''.join([chr(x) for x in res])

open('fancynounours.bin', 'wb').write(s)

print "Done!"
